<?php

/**
 * This code was generated by
 * \ / _    _  _|   _  _
 * | (_)\/(_)(_|\/| |(/_  v1.0.0
 * /       /
 */

namespace Twilio\Rest\Messaging\V1\Service;

use Twilio\Exceptions\TwilioException;
use Twilio\InstanceResource;
use Twilio\Values;
use Twilio\Version;

/**
 * PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
 *
 * @property array[] $usAppToPersonUsecases
 */
class UsAppToPersonUsecaseInstance extends InstanceResource {
    /**
     * Initialize the UsAppToPersonUsecaseInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $messagingServiceSid The unique string that identifies the
     *                                    resource
     */
    public function __construct(Version $version, array $payload, string $messagingServiceSid) {
        parent::__construct($version);

        // Marshaled Properties
        $this->properties = [
            'usAppToPersonUsecases' => Values::array_get($payload, 'us_app_to_person_usecases'),
        ];

        $this->solution = ['messagingServiceSid' => $messagingServiceSid, ];
    }

    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name) {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }

        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->$method();
        }

        throw new TwilioException('Unknown property: ' . $name);
    }

    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString(): string {
        return '[Twilio.Messaging.V1.UsAppToPersonUsecaseInstance]';
    }
}